# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['OrganizationBillingGroupArgs', 'OrganizationBillingGroup']

@pulumi.input_type
class OrganizationBillingGroupArgs:
    def __init__(__self__, *,
                 billing_address_id: pulumi.Input[builtins.str],
                 billing_contact_emails: pulumi.Input[Sequence[pulumi.Input[builtins.str]]],
                 billing_emails: pulumi.Input[Sequence[pulumi.Input[builtins.str]]],
                 billing_group_name: pulumi.Input[builtins.str],
                 organization_id: pulumi.Input[builtins.str],
                 payment_method_id: pulumi.Input[builtins.str],
                 shipping_address_id: pulumi.Input[builtins.str],
                 billing_currency: Optional[pulumi.Input[builtins.str]] = None,
                 custom_invoice_text: Optional[pulumi.Input[builtins.str]] = None,
                 timeouts: Optional[pulumi.Input['OrganizationBillingGroupTimeoutsArgs']] = None,
                 vat_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a OrganizationBillingGroup resource.
        :param pulumi.Input[builtins.str] billing_address_id: Billing address ID. Maximum length: `36`.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] billing_contact_emails: List of billing contact emails.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] billing_emails: List of billing contact emails.
        :param pulumi.Input[builtins.str] billing_group_name: Billing Group Name. Maximum length: `128`.
        :param pulumi.Input[builtins.str] organization_id: ID of an organization. Maximum length: `36`. Changing this property forces recreation of the resource.
        :param pulumi.Input[builtins.str] payment_method_id: Payment method ID.
        :param pulumi.Input[builtins.str] shipping_address_id: Shipping address ID. Maximum length: `36`.
        :param pulumi.Input[builtins.str] billing_currency: Acceptable currencies for a billing group. The possible values are `AUD`, `CAD`, `CHF`, `DKK`, `EUR`, `GBP`, `JPY`, `NOK`, `NZD`, `SEK`, `SGD` and `USD`.
        :param pulumi.Input[builtins.str] custom_invoice_text: Extra billing text. Maximum length: `254`.
        :param pulumi.Input[builtins.str] vat_id: VAT ID.
        """
        pulumi.set(__self__, "billing_address_id", billing_address_id)
        pulumi.set(__self__, "billing_contact_emails", billing_contact_emails)
        pulumi.set(__self__, "billing_emails", billing_emails)
        pulumi.set(__self__, "billing_group_name", billing_group_name)
        pulumi.set(__self__, "organization_id", organization_id)
        pulumi.set(__self__, "payment_method_id", payment_method_id)
        pulumi.set(__self__, "shipping_address_id", shipping_address_id)
        if billing_currency is not None:
            pulumi.set(__self__, "billing_currency", billing_currency)
        if custom_invoice_text is not None:
            pulumi.set(__self__, "custom_invoice_text", custom_invoice_text)
        if timeouts is not None:
            pulumi.set(__self__, "timeouts", timeouts)
        if vat_id is not None:
            pulumi.set(__self__, "vat_id", vat_id)

    @property
    @pulumi.getter(name="billingAddressId")
    def billing_address_id(self) -> pulumi.Input[builtins.str]:
        """
        Billing address ID. Maximum length: `36`.
        """
        return pulumi.get(self, "billing_address_id")

    @billing_address_id.setter
    def billing_address_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "billing_address_id", value)

    @property
    @pulumi.getter(name="billingContactEmails")
    def billing_contact_emails(self) -> pulumi.Input[Sequence[pulumi.Input[builtins.str]]]:
        """
        List of billing contact emails.
        """
        return pulumi.get(self, "billing_contact_emails")

    @billing_contact_emails.setter
    def billing_contact_emails(self, value: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        pulumi.set(self, "billing_contact_emails", value)

    @property
    @pulumi.getter(name="billingEmails")
    def billing_emails(self) -> pulumi.Input[Sequence[pulumi.Input[builtins.str]]]:
        """
        List of billing contact emails.
        """
        return pulumi.get(self, "billing_emails")

    @billing_emails.setter
    def billing_emails(self, value: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        pulumi.set(self, "billing_emails", value)

    @property
    @pulumi.getter(name="billingGroupName")
    def billing_group_name(self) -> pulumi.Input[builtins.str]:
        """
        Billing Group Name. Maximum length: `128`.
        """
        return pulumi.get(self, "billing_group_name")

    @billing_group_name.setter
    def billing_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "billing_group_name", value)

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> pulumi.Input[builtins.str]:
        """
        ID of an organization. Maximum length: `36`. Changing this property forces recreation of the resource.
        """
        return pulumi.get(self, "organization_id")

    @organization_id.setter
    def organization_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "organization_id", value)

    @property
    @pulumi.getter(name="paymentMethodId")
    def payment_method_id(self) -> pulumi.Input[builtins.str]:
        """
        Payment method ID.
        """
        return pulumi.get(self, "payment_method_id")

    @payment_method_id.setter
    def payment_method_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "payment_method_id", value)

    @property
    @pulumi.getter(name="shippingAddressId")
    def shipping_address_id(self) -> pulumi.Input[builtins.str]:
        """
        Shipping address ID. Maximum length: `36`.
        """
        return pulumi.get(self, "shipping_address_id")

    @shipping_address_id.setter
    def shipping_address_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "shipping_address_id", value)

    @property
    @pulumi.getter(name="billingCurrency")
    def billing_currency(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Acceptable currencies for a billing group. The possible values are `AUD`, `CAD`, `CHF`, `DKK`, `EUR`, `GBP`, `JPY`, `NOK`, `NZD`, `SEK`, `SGD` and `USD`.
        """
        return pulumi.get(self, "billing_currency")

    @billing_currency.setter
    def billing_currency(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "billing_currency", value)

    @property
    @pulumi.getter(name="customInvoiceText")
    def custom_invoice_text(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Extra billing text. Maximum length: `254`.
        """
        return pulumi.get(self, "custom_invoice_text")

    @custom_invoice_text.setter
    def custom_invoice_text(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "custom_invoice_text", value)

    @property
    @pulumi.getter
    def timeouts(self) -> Optional[pulumi.Input['OrganizationBillingGroupTimeoutsArgs']]:
        return pulumi.get(self, "timeouts")

    @timeouts.setter
    def timeouts(self, value: Optional[pulumi.Input['OrganizationBillingGroupTimeoutsArgs']]):
        pulumi.set(self, "timeouts", value)

    @property
    @pulumi.getter(name="vatId")
    def vat_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        VAT ID.
        """
        return pulumi.get(self, "vat_id")

    @vat_id.setter
    def vat_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "vat_id", value)


@pulumi.input_type
class _OrganizationBillingGroupState:
    def __init__(__self__, *,
                 billing_address_id: Optional[pulumi.Input[builtins.str]] = None,
                 billing_contact_emails: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 billing_currency: Optional[pulumi.Input[builtins.str]] = None,
                 billing_emails: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 billing_group_id: Optional[pulumi.Input[builtins.str]] = None,
                 billing_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 custom_invoice_text: Optional[pulumi.Input[builtins.str]] = None,
                 organization_id: Optional[pulumi.Input[builtins.str]] = None,
                 payment_method_id: Optional[pulumi.Input[builtins.str]] = None,
                 shipping_address_id: Optional[pulumi.Input[builtins.str]] = None,
                 timeouts: Optional[pulumi.Input['OrganizationBillingGroupTimeoutsArgs']] = None,
                 vat_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering OrganizationBillingGroup resources.
        :param pulumi.Input[builtins.str] billing_address_id: Billing address ID. Maximum length: `36`.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] billing_contact_emails: List of billing contact emails.
        :param pulumi.Input[builtins.str] billing_currency: Acceptable currencies for a billing group. The possible values are `AUD`, `CAD`, `CHF`, `DKK`, `EUR`, `GBP`, `JPY`, `NOK`, `NZD`, `SEK`, `SGD` and `USD`.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] billing_emails: List of billing contact emails.
        :param pulumi.Input[builtins.str] billing_group_id: Billing group ID.
        :param pulumi.Input[builtins.str] billing_group_name: Billing Group Name. Maximum length: `128`.
        :param pulumi.Input[builtins.str] custom_invoice_text: Extra billing text. Maximum length: `254`.
        :param pulumi.Input[builtins.str] organization_id: ID of an organization. Maximum length: `36`. Changing this property forces recreation of the resource.
        :param pulumi.Input[builtins.str] payment_method_id: Payment method ID.
        :param pulumi.Input[builtins.str] shipping_address_id: Shipping address ID. Maximum length: `36`.
        :param pulumi.Input[builtins.str] vat_id: VAT ID.
        """
        if billing_address_id is not None:
            pulumi.set(__self__, "billing_address_id", billing_address_id)
        if billing_contact_emails is not None:
            pulumi.set(__self__, "billing_contact_emails", billing_contact_emails)
        if billing_currency is not None:
            pulumi.set(__self__, "billing_currency", billing_currency)
        if billing_emails is not None:
            pulumi.set(__self__, "billing_emails", billing_emails)
        if billing_group_id is not None:
            pulumi.set(__self__, "billing_group_id", billing_group_id)
        if billing_group_name is not None:
            pulumi.set(__self__, "billing_group_name", billing_group_name)
        if custom_invoice_text is not None:
            pulumi.set(__self__, "custom_invoice_text", custom_invoice_text)
        if organization_id is not None:
            pulumi.set(__self__, "organization_id", organization_id)
        if payment_method_id is not None:
            pulumi.set(__self__, "payment_method_id", payment_method_id)
        if shipping_address_id is not None:
            pulumi.set(__self__, "shipping_address_id", shipping_address_id)
        if timeouts is not None:
            pulumi.set(__self__, "timeouts", timeouts)
        if vat_id is not None:
            pulumi.set(__self__, "vat_id", vat_id)

    @property
    @pulumi.getter(name="billingAddressId")
    def billing_address_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Billing address ID. Maximum length: `36`.
        """
        return pulumi.get(self, "billing_address_id")

    @billing_address_id.setter
    def billing_address_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "billing_address_id", value)

    @property
    @pulumi.getter(name="billingContactEmails")
    def billing_contact_emails(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        List of billing contact emails.
        """
        return pulumi.get(self, "billing_contact_emails")

    @billing_contact_emails.setter
    def billing_contact_emails(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "billing_contact_emails", value)

    @property
    @pulumi.getter(name="billingCurrency")
    def billing_currency(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Acceptable currencies for a billing group. The possible values are `AUD`, `CAD`, `CHF`, `DKK`, `EUR`, `GBP`, `JPY`, `NOK`, `NZD`, `SEK`, `SGD` and `USD`.
        """
        return pulumi.get(self, "billing_currency")

    @billing_currency.setter
    def billing_currency(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "billing_currency", value)

    @property
    @pulumi.getter(name="billingEmails")
    def billing_emails(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        List of billing contact emails.
        """
        return pulumi.get(self, "billing_emails")

    @billing_emails.setter
    def billing_emails(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "billing_emails", value)

    @property
    @pulumi.getter(name="billingGroupId")
    def billing_group_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Billing group ID.
        """
        return pulumi.get(self, "billing_group_id")

    @billing_group_id.setter
    def billing_group_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "billing_group_id", value)

    @property
    @pulumi.getter(name="billingGroupName")
    def billing_group_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Billing Group Name. Maximum length: `128`.
        """
        return pulumi.get(self, "billing_group_name")

    @billing_group_name.setter
    def billing_group_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "billing_group_name", value)

    @property
    @pulumi.getter(name="customInvoiceText")
    def custom_invoice_text(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Extra billing text. Maximum length: `254`.
        """
        return pulumi.get(self, "custom_invoice_text")

    @custom_invoice_text.setter
    def custom_invoice_text(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "custom_invoice_text", value)

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ID of an organization. Maximum length: `36`. Changing this property forces recreation of the resource.
        """
        return pulumi.get(self, "organization_id")

    @organization_id.setter
    def organization_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "organization_id", value)

    @property
    @pulumi.getter(name="paymentMethodId")
    def payment_method_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Payment method ID.
        """
        return pulumi.get(self, "payment_method_id")

    @payment_method_id.setter
    def payment_method_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "payment_method_id", value)

    @property
    @pulumi.getter(name="shippingAddressId")
    def shipping_address_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Shipping address ID. Maximum length: `36`.
        """
        return pulumi.get(self, "shipping_address_id")

    @shipping_address_id.setter
    def shipping_address_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "shipping_address_id", value)

    @property
    @pulumi.getter
    def timeouts(self) -> Optional[pulumi.Input['OrganizationBillingGroupTimeoutsArgs']]:
        return pulumi.get(self, "timeouts")

    @timeouts.setter
    def timeouts(self, value: Optional[pulumi.Input['OrganizationBillingGroupTimeoutsArgs']]):
        pulumi.set(self, "timeouts", value)

    @property
    @pulumi.getter(name="vatId")
    def vat_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        VAT ID.
        """
        return pulumi.get(self, "vat_id")

    @vat_id.setter
    def vat_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "vat_id", value)


@pulumi.type_token("aiven:index/organizationBillingGroup:OrganizationBillingGroup")
class OrganizationBillingGroup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 billing_address_id: Optional[pulumi.Input[builtins.str]] = None,
                 billing_contact_emails: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 billing_currency: Optional[pulumi.Input[builtins.str]] = None,
                 billing_emails: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 billing_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 custom_invoice_text: Optional[pulumi.Input[builtins.str]] = None,
                 organization_id: Optional[pulumi.Input[builtins.str]] = None,
                 payment_method_id: Optional[pulumi.Input[builtins.str]] = None,
                 shipping_address_id: Optional[pulumi.Input[builtins.str]] = None,
                 timeouts: Optional[pulumi.Input[Union['OrganizationBillingGroupTimeoutsArgs', 'OrganizationBillingGroupTimeoutsArgsDict']]] = None,
                 vat_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Creates and manages an organization billing group.

        **This resource is in the beta stage and may change without notice.** Set
        the `PROVIDER_AIVEN_ENABLE_BETA` environment variable to use the resource.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] billing_address_id: Billing address ID. Maximum length: `36`.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] billing_contact_emails: List of billing contact emails.
        :param pulumi.Input[builtins.str] billing_currency: Acceptable currencies for a billing group. The possible values are `AUD`, `CAD`, `CHF`, `DKK`, `EUR`, `GBP`, `JPY`, `NOK`, `NZD`, `SEK`, `SGD` and `USD`.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] billing_emails: List of billing contact emails.
        :param pulumi.Input[builtins.str] billing_group_name: Billing Group Name. Maximum length: `128`.
        :param pulumi.Input[builtins.str] custom_invoice_text: Extra billing text. Maximum length: `254`.
        :param pulumi.Input[builtins.str] organization_id: ID of an organization. Maximum length: `36`. Changing this property forces recreation of the resource.
        :param pulumi.Input[builtins.str] payment_method_id: Payment method ID.
        :param pulumi.Input[builtins.str] shipping_address_id: Shipping address ID. Maximum length: `36`.
        :param pulumi.Input[builtins.str] vat_id: VAT ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: OrganizationBillingGroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Creates and manages an organization billing group.

        **This resource is in the beta stage and may change without notice.** Set
        the `PROVIDER_AIVEN_ENABLE_BETA` environment variable to use the resource.

        :param str resource_name: The name of the resource.
        :param OrganizationBillingGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OrganizationBillingGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 billing_address_id: Optional[pulumi.Input[builtins.str]] = None,
                 billing_contact_emails: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 billing_currency: Optional[pulumi.Input[builtins.str]] = None,
                 billing_emails: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 billing_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 custom_invoice_text: Optional[pulumi.Input[builtins.str]] = None,
                 organization_id: Optional[pulumi.Input[builtins.str]] = None,
                 payment_method_id: Optional[pulumi.Input[builtins.str]] = None,
                 shipping_address_id: Optional[pulumi.Input[builtins.str]] = None,
                 timeouts: Optional[pulumi.Input[Union['OrganizationBillingGroupTimeoutsArgs', 'OrganizationBillingGroupTimeoutsArgsDict']]] = None,
                 vat_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OrganizationBillingGroupArgs.__new__(OrganizationBillingGroupArgs)

            if billing_address_id is None and not opts.urn:
                raise TypeError("Missing required property 'billing_address_id'")
            __props__.__dict__["billing_address_id"] = billing_address_id
            if billing_contact_emails is None and not opts.urn:
                raise TypeError("Missing required property 'billing_contact_emails'")
            __props__.__dict__["billing_contact_emails"] = billing_contact_emails
            __props__.__dict__["billing_currency"] = billing_currency
            if billing_emails is None and not opts.urn:
                raise TypeError("Missing required property 'billing_emails'")
            __props__.__dict__["billing_emails"] = billing_emails
            if billing_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'billing_group_name'")
            __props__.__dict__["billing_group_name"] = billing_group_name
            __props__.__dict__["custom_invoice_text"] = custom_invoice_text
            if organization_id is None and not opts.urn:
                raise TypeError("Missing required property 'organization_id'")
            __props__.__dict__["organization_id"] = organization_id
            if payment_method_id is None and not opts.urn:
                raise TypeError("Missing required property 'payment_method_id'")
            __props__.__dict__["payment_method_id"] = payment_method_id
            if shipping_address_id is None and not opts.urn:
                raise TypeError("Missing required property 'shipping_address_id'")
            __props__.__dict__["shipping_address_id"] = shipping_address_id
            __props__.__dict__["timeouts"] = timeouts
            __props__.__dict__["vat_id"] = vat_id
            __props__.__dict__["billing_group_id"] = None
        super(OrganizationBillingGroup, __self__).__init__(
            'aiven:index/organizationBillingGroup:OrganizationBillingGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            billing_address_id: Optional[pulumi.Input[builtins.str]] = None,
            billing_contact_emails: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            billing_currency: Optional[pulumi.Input[builtins.str]] = None,
            billing_emails: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            billing_group_id: Optional[pulumi.Input[builtins.str]] = None,
            billing_group_name: Optional[pulumi.Input[builtins.str]] = None,
            custom_invoice_text: Optional[pulumi.Input[builtins.str]] = None,
            organization_id: Optional[pulumi.Input[builtins.str]] = None,
            payment_method_id: Optional[pulumi.Input[builtins.str]] = None,
            shipping_address_id: Optional[pulumi.Input[builtins.str]] = None,
            timeouts: Optional[pulumi.Input[Union['OrganizationBillingGroupTimeoutsArgs', 'OrganizationBillingGroupTimeoutsArgsDict']]] = None,
            vat_id: Optional[pulumi.Input[builtins.str]] = None) -> 'OrganizationBillingGroup':
        """
        Get an existing OrganizationBillingGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] billing_address_id: Billing address ID. Maximum length: `36`.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] billing_contact_emails: List of billing contact emails.
        :param pulumi.Input[builtins.str] billing_currency: Acceptable currencies for a billing group. The possible values are `AUD`, `CAD`, `CHF`, `DKK`, `EUR`, `GBP`, `JPY`, `NOK`, `NZD`, `SEK`, `SGD` and `USD`.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] billing_emails: List of billing contact emails.
        :param pulumi.Input[builtins.str] billing_group_id: Billing group ID.
        :param pulumi.Input[builtins.str] billing_group_name: Billing Group Name. Maximum length: `128`.
        :param pulumi.Input[builtins.str] custom_invoice_text: Extra billing text. Maximum length: `254`.
        :param pulumi.Input[builtins.str] organization_id: ID of an organization. Maximum length: `36`. Changing this property forces recreation of the resource.
        :param pulumi.Input[builtins.str] payment_method_id: Payment method ID.
        :param pulumi.Input[builtins.str] shipping_address_id: Shipping address ID. Maximum length: `36`.
        :param pulumi.Input[builtins.str] vat_id: VAT ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OrganizationBillingGroupState.__new__(_OrganizationBillingGroupState)

        __props__.__dict__["billing_address_id"] = billing_address_id
        __props__.__dict__["billing_contact_emails"] = billing_contact_emails
        __props__.__dict__["billing_currency"] = billing_currency
        __props__.__dict__["billing_emails"] = billing_emails
        __props__.__dict__["billing_group_id"] = billing_group_id
        __props__.__dict__["billing_group_name"] = billing_group_name
        __props__.__dict__["custom_invoice_text"] = custom_invoice_text
        __props__.__dict__["organization_id"] = organization_id
        __props__.__dict__["payment_method_id"] = payment_method_id
        __props__.__dict__["shipping_address_id"] = shipping_address_id
        __props__.__dict__["timeouts"] = timeouts
        __props__.__dict__["vat_id"] = vat_id
        return OrganizationBillingGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="billingAddressId")
    def billing_address_id(self) -> pulumi.Output[builtins.str]:
        """
        Billing address ID. Maximum length: `36`.
        """
        return pulumi.get(self, "billing_address_id")

    @property
    @pulumi.getter(name="billingContactEmails")
    def billing_contact_emails(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        List of billing contact emails.
        """
        return pulumi.get(self, "billing_contact_emails")

    @property
    @pulumi.getter(name="billingCurrency")
    def billing_currency(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Acceptable currencies for a billing group. The possible values are `AUD`, `CAD`, `CHF`, `DKK`, `EUR`, `GBP`, `JPY`, `NOK`, `NZD`, `SEK`, `SGD` and `USD`.
        """
        return pulumi.get(self, "billing_currency")

    @property
    @pulumi.getter(name="billingEmails")
    def billing_emails(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        List of billing contact emails.
        """
        return pulumi.get(self, "billing_emails")

    @property
    @pulumi.getter(name="billingGroupId")
    def billing_group_id(self) -> pulumi.Output[builtins.str]:
        """
        Billing group ID.
        """
        return pulumi.get(self, "billing_group_id")

    @property
    @pulumi.getter(name="billingGroupName")
    def billing_group_name(self) -> pulumi.Output[builtins.str]:
        """
        Billing Group Name. Maximum length: `128`.
        """
        return pulumi.get(self, "billing_group_name")

    @property
    @pulumi.getter(name="customInvoiceText")
    def custom_invoice_text(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Extra billing text. Maximum length: `254`.
        """
        return pulumi.get(self, "custom_invoice_text")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> pulumi.Output[builtins.str]:
        """
        ID of an organization. Maximum length: `36`. Changing this property forces recreation of the resource.
        """
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter(name="paymentMethodId")
    def payment_method_id(self) -> pulumi.Output[builtins.str]:
        """
        Payment method ID.
        """
        return pulumi.get(self, "payment_method_id")

    @property
    @pulumi.getter(name="shippingAddressId")
    def shipping_address_id(self) -> pulumi.Output[builtins.str]:
        """
        Shipping address ID. Maximum length: `36`.
        """
        return pulumi.get(self, "shipping_address_id")

    @property
    @pulumi.getter
    def timeouts(self) -> pulumi.Output[Optional['outputs.OrganizationBillingGroupTimeouts']]:
        return pulumi.get(self, "timeouts")

    @property
    @pulumi.getter(name="vatId")
    def vat_id(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        VAT ID.
        """
        return pulumi.get(self, "vat_id")

